"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _browserLang = _interopRequireDefault(require("browser-lang"));

var _gatsby = require("gatsby");

var _intlContext = require("./intl-context");

var _reactLangapi = require("react-langapi");

var preferDefault = function preferDefault(m) {
  return m && m["default"] || m;
}; // const getLocaleData = locale => {
//   try {
//     const localeData = require(`react-intl/locale-data/${locale}`)
//     return localeData
//   } catch (e) {
//     return false
//   }
// }
// const addLocaleDataForGatsby = language => {
//   const locale = language.split("-")[0]
//   const localeData = getLocaleData(locale)
//   if (!localeData) {
//     throw new Error(`Cannot find react-intl/locale-data/${language}`)
//   }
//   addLocaleData(...localeData)
// }


var withIntlProvider = function withIntlProvider(intl) {
  return function (children) {
    // addLocaleDataForGatsby(intl.language)
    var client = intl.client,
        translationsPath = intl.translationsPath;
    client.setForceLanguage(intl.language);
    return _react["default"].createElement(_reactLangapi.LangProvider, {
      client: client,
      currentLanguage: intl.language
    }, _react["default"].createElement(_intlContext.IntlContextProvider, {
      value: intl
    }, children));
  };
};

var _default = function _default(_ref, pluginOptions) {
  var element = _ref.element,
      props = _ref.props;

  if (!props) {
    return;
  }

  var pageContext = props.pageContext,
      location = props.location;
  var intl = pageContext.intl;
  var language = intl.language,
      languages = intl.languages,
      redirect = intl.redirect,
      routed = intl.routed,
      allSitePage = intl.allSitePage,
      messages = intl.messages,
      defaultLanguage = intl.defaultLanguage; // Create langapi-client for SSR

  var client = require("langapi-client")("sk_prod_test", // TODO pass it in as part of config when we start using the API_KEY
  messages);

  if (typeof window !== "undefined") {
    window.___gatsbyIntl = intl;
  }

  var detected = (0, _browserLang["default"])({
    languages: languages,
    fallback: language
  });
  var isDefaultLanguage = detected === defaultLanguage;
  /* eslint-disable no-undef */

  var isRedirect = redirect && !routed && !isDefaultLanguage;

  if (isRedirect) {
    var pathname = location.pathname,
        search = location.search; // Skip build, Browsers only

    if (typeof window !== "undefined") {
      if (!languages.includes(detected)) {
        detected = language;
      }

      var queryParams = search || "";
      var newUrl = (0, _gatsby.withPrefix)("/" + detected + pathname + queryParams);

      if (allSitePage.includes(newUrl)) {
        window.location.replace(newUrl);
      } else {
        window.location.replace((0, _gatsby.withPrefix)("/" + detected + "/404"));
      }
    }
  }

  var renderElement = isRedirect ? GATSBY_INTL_REDIRECT_COMPONENT_PATH && _react["default"].createElement(preferDefault(require(GATSBY_INTL_REDIRECT_COMPONENT_PATH))) : element;
  return withIntlProvider((0, _extends2["default"])({}, intl, {
    client: client
  }))(renderElement);
};

exports["default"] = _default;